/*****************************************************************************
***************************** DISE ERROR MODULE ******************************
* version 0.00.000 ***********************************************************
*********************************************************** February 2005 ****
******************************************************************************
******************************************************************************
* Classes list:                                                              *
*    - class
*                                                                            *
* Functions list:                                                            *
*                                                                            *
* Revision history:
*                                                                            *
* Notes:
*                                                                            *
* Author: Miguel Jos                                                        *
*                                                                            *
* Copyright Miguel Jos 2005.                                                *
*                                                                            *
*****************************************************************************/

#include "DISEerr.H"
#include <iostream>

/*****************************************************************************
*                             GLOBAL STUFF !                                 *
*****************************************************************************/

std::fstream diserrorlog;

/* External variables */
//extern int I_am_an_external_variable;

/* Local variables */
static time_t now;

/* Typedefs */
//typedef definition identifier;



/*****************************************************************************
*                                Constants                                   *
*****************************************************************************/

// C++ const

// C #define

/*****************************************************************************
*                   Private Module Functions Prototypes                      *
*****************************************************************************/

/*****************************************************************************
*                               Class XXXXX                                  *
*****************************************************************************/


/*****************************************************************************
******************************************************************************
****               Module Public Functions Implementation                 ****
******************************************************************************
*****************************************************************************/

int opendiserrorlog()
{
   diserrorlog.open( "dise_err.txt", std::ios::out | std::ios::app ); // Log file
   if ( !diserrorlog )
   {
      std::cerr << "dise_err.txt file could not be opened\n";
      return -1;
   }
   time_t now;
   time(&now);
   diserrorlog << "Entry START " << asctime(localtime(&now));
   return 0;
}

int closediserrorlog()
{
   time(&now);
   diserrorlog << "Entry END " << asctime(localtime(&now));
   diserrorlog.close();
   return 0;
}
