/*****************************************************************************
****************************** DISELOG MODULE ********************************
* version 0.00.000 ***********************************************************
*********************************************************** February 2005 ****
******************************************************************************
******************************************************************************
* Classes list:                                                              *
*    - class
*                                                                            *
* Functions list:                                                            *
*                                                                            *
* Revision history: "Mike revised the code in 1499 BC, should be OK."        *
*                                                                            *
* Notes:
*                                                                            *
* Author: Miguel Jos                                                        *
*                                                                            *
* Copyright Miguel Jos 2005.                                                *
*                                                                            *
*****************************************************************************/

#include "DISElog.H"
#include <iostream>

/*****************************************************************************
*                             GLOBAL STUFF !                                 *
*****************************************************************************/

std::fstream diselog;

/* External variables */
//extern int I_am_an_external_variable;

/* Local variables */
static time_t now;

/* Typedefs */
//typedef definition identifier;



/*****************************************************************************
*                                Constants                                   *
*****************************************************************************/

// C++ const

// C #define

/*****************************************************************************
*                   Private Module Functions Prototypes                      *
*****************************************************************************/

/*****************************************************************************
*                               Class XXXXX                                  *
*****************************************************************************/


/*****************************************************************************
******************************************************************************
****               Module Public Functions Implementation                 ****
******************************************************************************
*****************************************************************************/

int opendiselog()
{
   diselog.open( "dise.log", std::ios::out | std::ios::app ); // Log file
   if ( !diselog )
   {
      std::cerr << "dise.log file could not be opened\n";
      return -1;
   }
   time(&now);
   diselog << "Entry START " << asctime(localtime(&now));
   return 0;
}

int closediselog()
{
   time(&now);
   diselog << "Entry END " << asctime(localtime(&now));
   diselog.close();
   return 0;
}
